/*!
 * Copyright (c) 2020 han_feng@foxmail.com
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 */
import Vue from"vue";import createVuexAlong from"vuex-along";import router from"./router";import store from"./store";var HOOK_KEYS=Object.freeze({beforeEach:!0,beforeResolve:!0,afterEach:!0,onReady:!0,onError:!0}),defaultAppComponent={name:"app",render:function(e){return e("router-view")}},defaultAppElement="#app";function addVuexModules(e){for(var o=e.getApplication(),t={name:"VAS:"+o.name+"-"+o.version},r=[],n=[],u=e.getExtension("vuex.modules"),a=0,i=Object.keys(u);a<i.length;a++){var s=i[a],l=u[s];store.registerModule(s,l),l.storage&&("session"===l.storage?n.push(s):"local"===l.storage&&r.push(s))}n.length>0&&(t.session={list:n}),r.length>0?t.local={list:r}:t.justSession=!0,createVuexAlong(t)(store)}function addPlugins(e){var o=e.getExtension("vue.plugins");null!==o&&o.forEach(function(e){return Vue.use(e)})}function addRoutes(e){var o=e.getExtension("vue.router.routes"),t=[],r={},n={};if(null!==o){o.forEach(function(e){if(e&&e.parent&&e.routes){var o,u=e.parent;"root"===u?o=t:void 0===(o=r[u])&&(n[u]=n[u]||[],o=n[u]),e.routes.forEach(function(e){o.push(e),function e(o){if(void 0!==o.children&&Array.isArray(o.children)){var t=o.name;if(void 0===t||""===t)return void console.log("Error: 路由名称未定义，"+JSON.stringify(o));var u=o.children;r[t]=u,n[t]&&(n[t].forEach(function(e){u.push(e)}),delete n[t]),o.children.forEach(function(o){e(o)})}}(e)})}});for(var u=0,a=Object.keys(n);u<a.length;u++){var i=a[u];console.log("Error: 父路由“"+i+"”不存在")}router.addRoutes(t),e.setAttribute("vue.routes",t)}}function addRouterHooks(e){var o=e.getExtension("vue.router.hooks");if(null!==o){var t=router;o.forEach(function(e){for(var o in e)void 0!==HOOK_KEYS[o]&&t[o](e[o])})}}function createVueInstance(e){var o=e.getExtension("vue.app")||{component:defaultAppComponent,element:defaultAppElement},t=o.component||defaultAppComponent,r={router:router,store:store,render:function(e){return e(t)}},n=e.getExtension("vue.options");null!==n&&(r.mixins=n);var u=new Vue(r),a=o.element||defaultAppElement;u.$mount(a),e.setAttribute("vue.instance",u)}var activator={start:function(e){addVuexModules(e),addPlugins(e),addRoutes(e),addRouterHooks(e),createVueInstance(e)}};export default activator;